# newmods.pl
# Updates an acl file to include new modules. Called with the parameters
# <config directory> <module>+

for($i=1; $i<@ARGV; $i++) {
	if (!(-d "$ARGV[0]/$ARGV[$i]")) {
		push(@new, $ARGV[$i]);
		}
	}

if (@new) {
	# Read in the existing file
	open(ACL, "$ARGV[0]/webmin.acl");
	@acl = <ACL>;
	close(ACL);

	# Find the right entry
	$pos = 0;
	for($i=0; $i<@acl; $i++) {
		if ($acl[$i] =~ /^(\S+):/ &&
		    ($1 eq 'root' || $1 eq 'admin')) {
			$pos = $i;
			last;
			}
		}

	# Update it with new modules
	$acl[$pos] =~ /^(\S+):\s*(.*)$/;
	$name = $1; @list = split(/\s+/, $2);
	foreach $o (@list) { $old{$o}++; }
	foreach $n (@new) {
		push(@list, $n) if (!$old{$n});
		}
	$acl[$pos] = "$name: ".join(" ",@list)."\n";

	# Write it out
	open(ACL, ">$ARGV[0]/webmin.acl");
	print ACL @acl;
	close(ACL);
	}

